'''This module implements the actual finalconfig application.
'''

import pygtk
import gtk
import dbus
import dbus.service
import dbus.mainloop.glib
import gobject

import finalconfig.session


class Application (dbus.service.Object):
 
    def __init__ (self):
        self.sessions = []
        self.session_handle = 0
        gobject.idle_add (self.started)
        
    def run (self):
        gtk.main()
        
    def started (self):
        dbus.mainloop.glib.DBusGMainLoop (set_as_default=True) 
        name = dbus.service.BusName ('de.zpages.FinalConfig', dbus.service.SessionBus())
        dbus.service.Object.__init__ (self, conn = dbus.SessionBus(),
            object_path = '/', bus_name = name)
        return False

    @dbus.service.method (dbus_interface='de.zpages.FinalConfig', in_signature='sss',
        out_signature='s')
    def start_session (self, config_path, desc_path, app_name):
        handle = '/session/%s' % self.session_handle
        self.session_handle = self.session_handle + 1
        session = finalconfig.session.Session (self, str (config_path), str (desc_path),
            handle, app_name)
        self.sessions.append (session)
        session.show()
        return handle
                        
    def close (self, session):
        self.sessions.remove (session)
        if len (self.sessions) == 0:
            gtk.main_quit()

